/*  2020/2021 Regional
    International Collegiate Programming Contest

    Problem ?
    Exoplanet Lighthouses
    M. K. Furon.                    2022-02-13.                       */




#include  <stdio.h>
#include  <stdlib.h>
#include  <math.h>




int iocount;
double answer, h1, h2, planetr;




void abend (char *message)
{
(void) fputs (message, stderr);
(void) fputc ('\n', stderr);
exit (4);
}




double surfaced (double radius, double height)
{
/*  Find the surface distance covered between a point tangent to the
    surface and a point at a given height above the surface.          */
double pointh, sideopposite, theta;
pointh = radius + height;
sideopposite = sqrt ((pointh * pointh) - (radius * radius));
theta = atan (sideopposite / radius);
return (theta * radius);
}





int main (int argc, char *argv[], char *envp[])
{
while ((iocount = scanf ("%lf %lf %lf", &planetr, &h1, &h2)) == 3)
   {
   /*  Do all calculations in meters.                                 */
   planetr *= 1000.0;
   /*  The maximum distance on the planet surface can be determined
       by solving for the total angle covered by two right triangles:
       one from the point at the surface to the observer, the other
       from the point at the surface to the beacon.                   */
   answer = surfaced (planetr, h2);
   answer += surfaced (planetr, h1);
   /*  Print answer in kilometers.                                    */
   answer *= 0.001;
   (void) printf ("%.9f\n", answer);
   }

if (iocount != EOF)
   abend ("Unexpected input after last test case.");

return (0);
}
