#include <stdlib.h>
#include <time.h>

#include <fstream>
#include <iostream>
#include <vector>

using namespace std;

const string ingredients[10] = {"sugar",  "salt",  "pepper", "water", "vinegar",
                                "garlic", "onion", "chili",  "oil",   "cream"};

const string sauces[104] = {
    "SauceAA", "SauceAB", "SauceAC", "SauceAD", "SauceAE", "SauceAF", "SauceAG",
    "SauceAH", "SauceAI", "SauceAJ", "SauceAK", "SauceAL", "SauceAM", "SauceAN",
    "SauceAO", "SauceAP", "SauceAQ", "SauceAR", "SauceAS", "SauceAT", "SauceAU",
    "SauceAV", "SauceAW", "SauceAX", "SauceAY", "SauceAZ", "SauceBA", "SauceBB",
    "SauceBC", "SauceBD", "SauceBE", "SauceBF", "SauceBG", "SauceBH", "SauceBI",
    "SauceBJ", "SauceBK", "SauceBL", "SauceBM", "SauceBN", "SauceBO", "SauceBP",
    "SauceBQ", "SauceBR", "SauceBS", "SauceBT", "SauceBU", "SauceBV", "SauceBW",
    "SauceBX", "SauceBY", "SauceBZ", "SauceCA", "SauceCB", "SauceCC", "SauceCD",
    "SauceCE", "SauceCF", "SauceCG", "SauceCH", "SauceCI", "SauceCJ", "SauceCK",
    "SauceCL", "SauceCM", "SauceCN", "SauceCO", "SauceCP", "SauceCQ", "SauceCR",
    "SauceCS", "SauceCT", "SauceCU", "SauceCV", "SauceCW", "SauceCX", "SauceCY",
    "SauceCZ", "SauceDA", "SauceDB", "SauceDC", "SauceDD", "SauceDE", "SauceDF",
    "SauceDG", "SauceDH", "SauceDI", "SauceDJ", "SauceDK", "SauceDL", "SauceDM",
    "SauceDN", "SauceDO", "SauceDP", "SauceDQ", "SauceDR", "SauceDS", "SauceDT",
    "SauceDU", "SauceDV", "SauceDW", "SauceDX", "SauceDY", "SauceDZ"};

int m = 8, n = 100, l = 100, p = 3, pt = m, u = 1, ut = 4;

string Component(int index) {
  if (index < m) {
    return ingredients[index];
  } else {
    return sauces[index - m];
  }
}

int RandomNumber(int from, int to) { return (rand() % (to - from + 1)) + from; }

vector<int> RandomNumbers(int m, int k) {
  vector<int> numbers(k);
  vector<bool> used(m);
  for (int i = 0; i < k; ++i) {
    int index = RandomNumber(0, m - 1);
    while (used[index]) {
      index = RandomNumber(0, m - 1);
    }
    used[index] = true;
    numbers[i] = index;
  }
  return numbers;
}

vector<int> RandomPermutation(int n) {
  vector<int> numbers(n);
  for (int i = 0; i < n; ++i) {
    numbers[i] = i;
    int j = RandomNumber(0, i);
    int tmp = numbers[i];
    numbers[i] = numbers[j];
    numbers[j] = tmp;
  }
  return numbers;
}

int main() {
  srand(time(NULL));
  cout << m << endl;
  for (int i = 0; i < m; ++i) {
    cout << ingredients[i] << endl;
  }
  cout << n << endl;
  vector<int> permutation = RandomPermutation(n);
  for (int i = 0; i < n; ++i) {
    cout << sauces[permutation[i]];
    int k = RandomNumber(2, p);
    if (k > m + permutation[i]) k = m + permutation[i];
    cout << " " << k;
    vector<int> component_indices = RandomNumbers(m + permutation[i], k);
    for (int j = 0; j < k; ++j) {
      cout << " " << Component(component_indices[j]);
      cout << " " << RandomNumber(1, u);
    }
    cout << endl;
  }
  cout << l << endl;
  if (l > m + n) l = m + n;
  vector<int> indices = RandomNumbers(m + n, l);
  for (int i = 0; i < l; ++i) {
    cout << Component(indices[i]) << endl;
  }
  int k = RandomNumber(pt, pt);
  if (k > m) k = m;
  cout << k;
  vector<int> ingredient_indices = RandomNumbers(m, k);
  for (int i = 0; i < k; ++i) {
    cout << " " << ingredients[ingredient_indices[i]];
    cout << " " << RandomNumber(ut, ut);
  }
  cout << endl;
  return 0;
}