#include <iostream>
#include <map>
#include <vector>
#include <string>
using namespace std ;
using ll = __int128_t ;
map<string, int> ingm ;
vector<ll> recip, dp, xv ;
vector<int> stock, mult ;
vector<vector<pair<string, int>>> raw ;
int m ;
/*  Saturating arithmetic per nybble; max value is 7 */
const ll OVBITS = 0x88888888LL ;
ll sum(ll a, ll b) {
   ll r = a + b ;
   if (r & OVBITS) {
      ll ov = r & OVBITS ;
      r = (r & ~ov) | (ov - (ov >> 3)) ;
   }
   return r ;
}
ll mul(ll v, int sm) {
   ll r = v ;
   for (int i=1; i<sm; i++)
      r = sum(r, v) ;
   return r ;
}
ll expand(int w) {
   if (recip[w] != 0)
      return recip[w] ;
   ll r = 0 ;
   for (int i=0; i<(int)raw[w].size(); i++)
      r = sum(r, mul(expand(ingm[raw[w][i].first]), raw[w][i].second)) ;
   recip[w] = r ;
   return r ;
}
void fillxv(int at, int ind, ll sofar) {
   if (at == m)
      xv[ind] = sofar ;
   else
      for (int i=0; i<mult[at]; i++)
         fillxv(at+1, ind*mult[at]+i, sofar + (i << (4 * at))) ;
}
int main() {
   int n, cnt ;
   cin >> m ;
   string nam ;
   recip.resize(m) ;
   for (int i=0; i<m; i++) {
      cin >> nam ;
      ingm[nam] = i ;
      recip[i] = 1LL << (4 * i) ;
   }
   cin >> n ;
   raw.resize(n+m) ;
   for (int i=0; i<n; i++) {
      cin >> nam ;
      ingm[nam] = i + m ;
      int k ;
      cin >> k ;
      for (int j=0; j<k; j++) {
         cin >> nam >> cnt ;
         raw[i+m].push_back({nam, cnt}) ;
      }
   }
   recip.resize(n+m) ;
   for (int i=0; i<n; i++)
      expand(i+m) ;
   int el ;
   cin >> el ;
   for (int i=0; i<el; i++) {
      cin >> nam ;
      stock.push_back(ingm[nam]) ;
   }
   int kt ;
   cin >> kt ;
   ll ss = 0 ;
   ll ovc = 0 ;
   mult.resize(m, 1) ;
   for (int i=0; i<m; i++)
      ovc += 7LL << (4 * i) ;
   int hi = 1 ;
   for (int i=0; i<kt; i++) {
      cin >> nam >> cnt ;
      int ii = ingm[nam] ;
      mult[ii] = cnt + 1 ;
      hi *= (cnt + 1) ;
      ss += cnt << (4 * ii) ;
   }
   ovc -= ss ;
   dp.resize(hi) ;
   dp[0] = 1 ;
   xv.resize(hi) ;
   fillxv(0, 0, 0) ;
   for (auto s: stock) {
      ll v = recip[s] ;
      int max = 4 ;
      int sv = 0 ;
      for (int i=0; i<m; i++) {
         int fromi = 7 & (v >> (4 * i)) ;
         sv = sv * mult[i] + fromi ;
         if (fromi)
            max = min(max, (int)(7 & (ss >> (4 * i))) / fromi) ;
      }
      if (max) {
         for (int i=hi-1; i>=0; i--) {
            ll cv = xv[i] ;
            ll s = dp[i] ;
            int j = i ;
            while (((cv - v) & OVBITS) == 0) {
               cv -= v ;
               j -= sv ;
               s += dp[j] ;
            }
            dp[i] = s ;
         }
      }
   }
   cout << (long long)dp[hi-1] << endl ;
}
